Index: trunk/NEMO/OPA_SRC/DTA/dtasal.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DTA/dtasal.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/DTA/dtasal.F90	(revision 16)
@@ -23,7 +23,7 @@
    
    !! * Shared module variables
-   LOGICAL , PUBLIC, PARAMETER ::   lk_dtasal = .TRUE.    ! salinity data flag
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &
-      s_dta       ! salinity data at given time-step
+   LOGICAL , PUBLIC, PARAMETER ::   lk_dtasal = .TRUE.    !: salinity data flag
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &  !:
+      s_dta       !: salinity data at given time-step
 
    !! * Module variables
@@ -81,6 +81,7 @@
       INTEGER ::   ji, jj, jk, jl    ! dummy loop indicies
       INTEGER ::   &
-         imois, iman, ik, i15,  &  ! temporary integers
-         ipi, ipj, ipk, itime      !    "          "
+         imois, iman, ik, i15,       &  ! temporary integers
+         ipi, ipj, ipk, itime,       &  !    "          "
+         il0, il1, ii0, ii1, ij0, ij1   !    "          "
       INTEGER, DIMENSION(jpmois) ::   istep
       REAL(wp) ::   &
@@ -186,7 +187,8 @@
             !                                        !  ORCA_R2 configuration
             !                                        ! =======================
-         
-            DO jj = mj0(101), mj1(109)                      ! Reduced salinity in the Alboran Sea
-               DO ji = mi0(141), mi1(155)
+            ij0 = 101   ;   ij1 = 109
+            ii0 = 141   ;   ii1 = 155   
+            DO jj = mj0(ij0), mj1(ij1)                      ! Reduced salinity in the Alboran Sea
+               DO ji = mi0(ii0), mi1(ii1)
                   DO jk = 13, 13
                      saldta(ji,jj,jk,:) = saldta(ji,jj,jk,:) - 0.15
@@ -205,11 +207,18 @@
             IF( n_cla == 1 ) THEN 
                !                                         ! New salinity profile at Gibraltar
-               saldta( mi0(139):mi1(139) , mj0(101):mj1(101) , : , : ) =   &
-                  &                                    saldta( mi0(138):mi1(138) , mj0(101):mj1(101) , : , : )
-               saldta( mi0(139):mi1(139) , mj0(102):mj1(102) , : , : ) =   &
-                  &                                    saldta( mi0(138):mi1(138) , mj0(102):mj1(102) , : , : )
-               DO jl = mi0(138), mi1(138)                ! New temperature profile at Gibraltar
-                  DO jj = mj0(101), mj1(102)
-                     DO ji = mi0(139), mi1(139)
+               il0 = 138   ;   il1 = 138   
+               ij0 = 101   ;   ij1 = 101
+               ii0 = 139   ;   ii1 = 139   
+               saldta( mi0(ii0):mi1(ii1), mj0(ij0):mj1(ij1) , : , : ) =   &
+                  &                                    saldta( mi0(il0):mi1(il1) , mj0(ij0):mj1(ij1) , : , : )
+               ij0 = 101   ;   ij1 = 101
+               saldta( mi0(ii0):mi1(ii1), mj0(ij0):mj1(ij1) , : , : ) =   &
+                  &                                    saldta( mi0(il0):mi1(il1) , mj0(ij0):mj1(ij1) , : , : )
+               il0 = 138   ;   il1 = 138   
+               ij0 = 101   ;   ij1 = 102
+               ii0 = 139   ;   ii1 = 139   
+               DO jl = mi0(ii0), mi1(ii1)                ! New salinity profile at Gibraltar
+                  DO jj = mj0(ij0), mj1(ij1)
+                     DO ji = mi0(ii0), mi1(ii1)
                         saldta(ji,jj,:,:) = saldta(jl,jj,:,:)
                      END DO
@@ -217,12 +226,16 @@
                END DO
 
-               DO jl = mi0(164), mi1(164)                ! New salinity profile at Bab el Mandeb
-                  DO jj = mj0(88), mj1(88)
-                     DO ji = mi0(161), mi1(163)
+               il0 = 164   ;   il1 = 164   
+               ij0 =  88   ;   ij1 =  88
+               ii0 = 161   ;   ii1 = 163   
+               DO jl = mi0(ii0), mi1(ii1)                ! New salinity profile at Bab el Mandeb
+                  DO jj = mj0(ij0), mj1(ij1)
+                     DO ji = mi0(ii0), mi1(ii1)
                         saldta(ji,jj,:,:) = saldta(jl,jj,:,:)
                      END DO
                   END DO
-                  DO jj = mj0(87), mj1(87)
-                     DO ji = mi0(161), mi1(163)
+                  ij0 =  87   ;   ij1 =  87
+                  DO jj = mj0(ij0), mj1(ij1)
+                     DO ji = mi0(ii0), mi1(ii1)
                         saldta(ji,jj,:,:) = saldta(jl,jj,:,:)
                      END DO
@@ -280,8 +293,8 @@
    !!   Default option:                                    NO salinity data
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_dtasal = .FALSE.   ! salinity data flag
+   LOGICAL , PUBLIC, PARAMETER ::   lk_dtasal = .FALSE.   !: salinity data flag
 CONTAINS
    SUBROUTINE dta_sal( kt )        ! Empty routine
-      WRITE(*,*) kt
+      WRITE(*,*) 'dta_sal: You should not have seen this print! error?', kt
    END SUBROUTINE dta_sal
 #endif
Index: trunk/NEMO/OPA_SRC/DTA/dtasst.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DTA/dtasst.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/DTA/dtasst.F90	(revision 16)
@@ -26,12 +26,12 @@
    !! * Shared module variables
 #if defined key_dtasst
-   LOGICAL , PUBLIC, PARAMETER ::   lk_dtasst = .TRUE.   ! sst data flag
+   LOGICAL , PUBLIC, PARAMETER ::   lk_dtasst = .TRUE.   !: sst data flag
 #else
-   LOGICAL , PUBLIC, PARAMETER ::   lk_dtasst = .TRUE.   ! sst data flag
+   LOGICAL , PUBLIC, PARAMETER ::   lk_dtasst = .FALSE.  !: sst data flag
 #endif
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   &
-      sst             ! surface temperature
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,2) ::   &
-      rclice          ! climatological ice index (0/1) (2 months)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   &  !:
+      sst             !: surface temperature
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,2) ::   &  !:
+      rclice          !: climatological ice index (0/1) (2 months)
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , IPSL-LODYC  (2003)
Index: trunk/NEMO/OPA_SRC/DTA/dtatem.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DTA/dtatem.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/DTA/dtatem.F90	(revision 16)
@@ -23,7 +23,7 @@
 
    !! * Shared module variables
-   LOGICAL , PUBLIC, PARAMETER ::   lk_dtatem = .TRUE.   ! temperature data flag
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &
-      t_dta             ! temperature data at given time-step
+   LOGICAL , PUBLIC, PARAMETER ::   lk_dtatem = .TRUE.   !: temperature data flag
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &  !:
+      t_dta             !: temperature data at given time-step
 
    !! * Module variables
@@ -91,5 +91,6 @@
       INTEGER ::   &
          imois, iman, itime, ik ,    &  ! temporary integers
-         i15, ipi, ipj, ipk             !    "          "
+         i15, ipi, ipj, ipk,         &  !    "          "
+         il0, il1, ii0, ii1, ij0, ij1   !    "          "
 
       INTEGER, DIMENSION(jpmois) ::   istep
@@ -192,6 +193,8 @@
             !                                        ! ======================= 
 
-            DO jj = mj0(101), mj1(109)                   ! Reduced temperature at Alboran Sea
-               DO ji = mi0(141), mi1(155)
+            ij0 = 101   ;   ij1 = 109
+            ii0 = 141   ;   ii1 = 155
+            DO jj = mj0(ij0), mj1(ij1)                      ! Reduced temperature in the Alboran Sea
+               DO ji = mi0(ii0), mi1(ii1)
                   temdta(ji,jj, 13:13 ,:) = temdta(ji,jj, 13:13 ,:) - 0.20
                   temdta(ji,jj, 14:15 ,:) = temdta(ji,jj, 14:15 ,:) - 0.35
@@ -202,23 +205,32 @@
             IF( n_cla == 0 ) THEN 
                !                                         ! Reduced temperature at Red Sea
-               temdta( mi0(148):mi1(160) , mj0(87):mj1(96) ,  4:10 , : ) = 7.0 
-               temdta( mi0(148):mi1(160) , mj0(87):mj1(96) , 11:13 , : ) = 6.5 
-               temdta( mi0(148):mi1(160) , mj0(87):mj1(96) , 14:20 , : ) = 6.0
+               ij0 =  87   ;   ij1 =  96
+               ii0 = 148   ;   ii1 = 160
+               temdta( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ,  4:10 , : ) = 7.0 
+               temdta( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , 11:13 , : ) = 6.5 
+               temdta( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , 14:20 , : ) = 6.0
             ELSE
-               DO jl = mi0(138), mi1(138)                ! New temperature profile at Gibraltar
-                  DO jj = mj0(101), mj1(102)
-                     DO ji = mi0(139), mi1(139)
+               il0 = 138   ;   il1 = 138
+               ij0 = 101   ;   ij1 = 102
+               ii0 = 139   ;   ii1 = 139
+               DO jl = mi0(ii0), mi1(ii1)                ! New temperature profile at Gibraltar
+                  DO jj = mj0(ij0), mj1(ij1)
+                     DO ji = mi0(ii0), mi1(ii1)
                         temdta(ji,jj,:,:) = temdta(jl,jj,:,:)
                      END DO
                   END DO
                END DO
-               DO jl = mi0(164), mi1(164)                ! New temperature profile at Bab el Mandeb
-                  DO jj = mj0(88), mj1(88)
-                     DO ji = mi0(161), mi1(163)
+               il0 = 164   ;   il1 = 164
+               ij0 =  88   ;   ij1 =  88
+               ii0 = 161   ;   ii1 = 163
+               DO jl = mi0(ii0), mi1(ii1)                ! New temperature profile at Bab el Mandeb
+                  DO jj = mj0(ij0), mj1(ij1)
+                     DO ji = mi0(ii0), mi1(ii1)
                         temdta(ji,jj,:,:) = temdta(jl,jj,:,:)
                      END DO
                   END DO
-                  DO jj = mj0(87), mj1(87)
-                     DO ji = mi0(161), mi1(163)
+                  ij0 =  87   ;   ij1 =  87
+                  DO jj = mj0(ij0), mj1(ij1)
+                     DO ji = mi0(ii0), mi1(ii1)
                         temdta(ji,jj,:,:) = temdta(jl,jj,:,:)
                      END DO
@@ -274,8 +286,8 @@
    !!   Default case                           NO 3D temperature data field
    !!----------------------------------------------------------------------
-   LOGICAL , PUBLIC, PARAMETER ::   lk_dtatem = .FALSE.   ! temperature data flag
+   LOGICAL , PUBLIC, PARAMETER ::   lk_dtatem = .FALSE.   !: temperature data flag
 CONTAINS
    SUBROUTINE dta_tem( kt )        ! Empty routine
-      WRITE(*,*) kt
+      WRITE(*,*) 'dta_tem: You should not have seen this print! error?', kt
    END SUBROUTINE dta_tem
 #endif
Index: trunk/NEMO/OPA_SRC/FLO/flo4rk.F90
===================================================================
--- trunk/NEMO/OPA_SRC/FLO/flo4rk.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/FLO/flo4rk.F90	(revision 16)
@@ -15,4 +15,5 @@
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
+   USE in_out_manager  ! I/O manager
 
    IMPLICIT NONE
@@ -24,10 +25,10 @@
    !! * Module variables
    REAL(wp), DIMENSION (4) ::   &   ! RK4 and Lagrange interpolation
-      tcoef1 = /  1.0  ,  0.5  ,  0.5  ,  0.0  / ,  &  ! coeffients  for 
-      tcoef2 = /  0.0  ,  0.5  ,  0.5  ,  1.0  / ,  &  ! lagrangian interp.
-      scoef2 = /  1.0  ,  2.0  ,  2.0  ,  1.0  / ,  &  ! RK4 coefficients
-      rcoef  = /-1./6. , 1./2. ,-1./2. , 1./6. /       ! ???
+      tcoef1 = (/  1.0  ,  0.5  ,  0.5  ,  0.0  /) ,  &  ! coeffients  for 
+      tcoef2 = (/  0.0  ,  0.5  ,  0.5  ,  1.0  /) ,  &  ! lagrangian interp.
+      scoef2 = (/  1.0  ,  2.0  ,  2.0  ,  1.0  /) ,  &  ! RK4 coefficients
+      rcoef  = (/-1./6. , 1./2. ,-1./2. , 1./6. /)       ! ???
    REAL(wp), DIMENSION (3) ::   &
-      scoef1 = / .5, .5, 1. /       ! compute position with interpolated
+      scoef1 = (/ .5, .5, 1. /)       ! compute position with interpolated
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LODYC-IPSL  (2003)
Index: trunk/NEMO/OPA_SRC/FLO/flo_oce.F90
===================================================================
--- trunk/NEMO/OPA_SRC/FLO/flo_oce.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/FLO/flo_oce.F90	(revision 16)
@@ -11,5 +11,5 @@
    !!  OPA 9.0 , LODYC-IPSL (2003)
    !!----------------------------------------------------------------------
-#if defined key_floats
+#if   defined key_floats   ||   defined key_esopa
    !!----------------------------------------------------------------------
    !!   'key_floats'                                        drifting floats
@@ -20,12 +20,12 @@
    IMPLICIT NONE
 
-   LOGICAL, PUBLIC, PARAMETER ::   lk_floats = .TRUE.    ! float flag
+   LOGICAL, PUBLIC, PARAMETER ::   lk_floats = .TRUE.    !: float flag
 
    !! float parameters
    !! ----------------
    INTEGER, PARAMETER ::   &
-      jpnfl      = 23 ,          &  ! total number of floats during the run
-      jpnnewfl   =  0 ,          &  ! number of floats added in a new run
-      jpnrstarfl = jpnfl-jpnnewfl   ! number of floats for the restart
+      jpnfl     = 23 ,            &  ! total number of floats during the run
+      jpnnewflo =  0 ,            &  ! number of floats added in a new run
+      jpnrstflo = jpnfl-jpnnewflo    ! number of floats for the restart
 
    !! float variables
@@ -61,5 +61,5 @@
    !!   Default option :                                 NO drifting floats
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_floats = .FALSE.   ! float flag
+   LOGICAL, PUBLIC, PARAMETER ::   lk_floats = .FALSE.   !: float flag
 #endif
 
Index: trunk/NEMO/OPA_SRC/FLO/floats.F90
===================================================================
--- trunk/NEMO/OPA_SRC/FLO/floats.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/FLO/floats.F90	(revision 16)
@@ -67,7 +67,6 @@
       ENDIF
 
-# if defined key_mpp
-      CALL mppsync
-# endif
+      IF( lk_mpp )   CALL mppsync   ! synchronization of all the processor
+
 
       ! Writing and restart      
@@ -98,10 +97,10 @@
 
       !! * Local declarations
-      NAMELIST/namflo/ ln_rstarfl, nwritefl, nstockfl 
+      NAMELIST/namflo/ ln_rstflo, nwritefl, nstockfl 
       !!---------------------------------------------------------------------
       ! Namelist namflo : floats
       
       ! default values
-      ln_rstarfl  = .FALSE.
+      ln_rstflo  = .FALSE.
       nwritefl  = 150
       nstockfl  = 450
@@ -114,7 +113,7 @@
          WRITE(numout,*) ' '
          WRITE(numout,*) '         Namelist floats :'
-         WRITE(numout,*) '            restart                          ln_rstarfl = ', ln_rstarfl
-         WRITE(numout,*) '            frequency of float output file   nwritefl   = ', nwritefl
-         WRITE(numout,*) '            frequency of float restart file  nstockfl   = ', nstockfl
+         WRITE(numout,*) '            restart                          ln_rstflo = ', ln_rstflo
+         WRITE(numout,*) '            frequency of float output file   nwritefl  = ', nwritefl
+         WRITE(numout,*) '            frequency of float restart file  nstockfl  = ', nstockfl
          WRITE(numout,*) ' '
       ENDIF
@@ -128,5 +127,5 @@
 CONTAINS
    SUBROUTINE flo_stp( kt )          ! Empty routine
-      WRITE(*,*) kt
+      WRITE(*,*) 'flo_stp: You should not have seen this print! error?', kt
    END SUBROUTINE flo_stp
 #endif
Index: trunk/NEMO/OPA_SRC/FLO/floblk.F90
===================================================================
--- trunk/NEMO/OPA_SRC/FLO/floblk.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/FLO/floblk.F90	(revision 16)
@@ -17,4 +17,5 @@
    USE dom_oce         ! ocean space and time domain
    USE phycst          ! physical constants
+   USE in_out_manager  ! I/O manager
    USE lib_mpp         ! distribued memory computing library
 
@@ -105,5 +106,5 @@
       iloop = 0
 222   DO jfl = 1, jpnfl
-# if defined key_mpp
+# if   defined key_mpp_mpi   ||   defined key_mpp_shmem
          IF( (iil(jfl) >= (mig(nldi)-jpizoom+1)) .AND. (iil(jfl) <= (mig(nlei)-jpizoom+1)) .AND.   &
              (ijl(jfl) >= (mjg(nldj)-jpjzoom+1)) .AND. (ijl(jfl) <= (mjg(nlej)-jpjzoom+1)) ) THEN
@@ -320,5 +321,5 @@
             ! reinitialisation of the age of FLOAT
             zagefl(jfl) = zagenewfl(jfl)
-# if defined key_mpp
+# if   defined key_mpp_mpi   ||   defined key_mpp_shmem
          ELSE
             ! we put zgifl, zgjfl, zgkfl, zagefl
@@ -334,14 +335,10 @@
       
       ! synchronisation
-      ! sum of this arrays
-            
-# if defined key_mpp
-      CALL mpp_sum( zgifl , jpnfl )
-      CALL mpp_sum( zgjfl , jpnfl )
-      CALL mpp_sum( zgkfl , jpnfl )
-      CALL mpp_sum( zagefl, jpnfl )
-      CALL mpp_sum( iil   , jpnfl )
-      CALL mpp_sum( ijl   , jpnfl )
-# endif
+      IF( lk_mpp )   CALL mpp_sum( zgifl , jpnfl )   ! sums over the global domain
+      IF( lk_mpp )   CALL mpp_sum( zgjfl , jpnfl )
+      IF( lk_mpp )   CALL mpp_sum( zgkfl , jpnfl )
+      IF( lk_mpp )   CALL mpp_sum( zagefl, jpnfl )
+      IF( lk_mpp )   CALL mpp_sum( iil   , jpnfl )
+      IF( lk_mpp )   CALL mpp_sum( ijl   , jpnfl )
       
       ! in the case of open boundaries we need to test if the floats don't
Index: trunk/NEMO/OPA_SRC/FLO/flodom.F90
===================================================================
--- trunk/NEMO/OPA_SRC/FLO/flodom.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/FLO/flodom.F90	(revision 16)
@@ -13,7 +13,9 @@
    !!----------------------------------------------------------------------
    !! * Modules used
-   USE flo_oce         ! ocean drifting floats
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
+   USE flo_oce         ! ocean drifting floats
+!  USE floats
+   USE in_out_manager  ! I/O manager
    USE lib_mpp         ! distribued memory computing library
 
@@ -43,14 +45,14 @@
       !!----------------------------------------------------------------------      
       !! * Local declarations
-      LOGICAL   :: llinmesh
+      LOGICAL  :: llinmesh
       CHARACTER (len=21) ::  clname
-      INTEGER   :: ji, jj, jk               ! DO loop index on 3 directions
-      INTEGER   :: jfl, jfl1                ! number of floats   
-      INTEGER   :: inum = 11                ! logical unit for file read
-      INTEGER , DIMENSION ( jpnfl    )  ::   &
+      INTEGER  :: ji, jj, jk               ! DO loop index on 3 directions
+      INTEGER  :: jfl, jfl1                ! number of floats   
+      INTEGER  :: inum = 11                ! logical unit for file read
+      INTEGER, DIMENSION ( jpnfl    )  ::   &
          iimfl, ijmfl, ikmfl,    &          ! index mesh of floats
          idomfl,  ivtest, ihtest
-      REAL(wp)  :: zdxab,zdyad
-      REAL(wp) , DIMENSION ( jpnnewfl )  :: zgifl, zgjfl,  zgkfl
+      REAL(wp) :: zdxab, zdyad
+      REAL(wp), DIMENSION ( jpnnewflo+1 )  :: zgifl, zgjfl,  zgkfl
       !!---------------------------------------------------------------------
       
@@ -61,5 +63,5 @@
       IF(lwp) WRITE(numout,*) '           jpnfl = ',jpnfl
       
-      IF(ln_rstarfl) THEN
+      IF(ln_rstflo) THEN
          IF(lwp) WRITE(numout,*) '        float restart file read'
          
@@ -70,14 +72,14 @@
 
          ! read of the restart file
-         READ(inum) ( tpifl  (jfl), jfl=1, jpnrstarfl),   & 
-                        ( tpjfl  (jfl), jfl=1, jpnrstarfl),   &
-                        ( tpkfl  (jfl), jfl=1, jpnrstarfl),   &
-                        ( nisobfl(jfl), jfl=1, jpnrstarfl),   &
-                        ( ngrpfl (jfl), jfl=1, jpnrstarfl)    
+         READ(inum) ( tpifl  (jfl), jfl=1, jpnrstflo),   & 
+                        ( tpjfl  (jfl), jfl=1, jpnrstflo),   &
+                        ( tpkfl  (jfl), jfl=1, jpnrstflo),   &
+                        ( nisobfl(jfl), jfl=1, jpnrstflo),   &
+                        ( ngrpfl (jfl), jfl=1, jpnrstflo)    
          CLOSE(inum)
 
          ! if we want a  surface drift  ( like PROVOR floats )
          IF( ln_argo ) THEN
-            DO jfl = 1, jpnrstarfl
+            DO jfl = 1, jpnrstflo
                nisobfl(jfl) = 0
             END DO
@@ -87,10 +89,10 @@
          
          ! It is possible to add new floats.          
-         IF(lwp) WRITE(numout,*)' flo_dom:jpnfl jpnrstarfl ',jpnfl,jpnrstarfl
-         IF( jpnfl > jpnrstarfl ) THEN
+         IF(lwp) WRITE(numout,*)' flo_dom:jpnfl jpnrstflo ',jpnfl,jpnrstflo
+         IF( jpnfl > jpnrstflo ) THEN
             ! open the init file 
             clname='init_float'
             OPEN(inum,FILE=clname,FORM='FORMATTED')
-            DO jfl = jpnrstarfl+1, jpnfl
+            DO jfl = jpnrstflo+1, jpnfl
                READ(inum,*) flxx(jfl),flyy(jfl),flzz(jfl), nisobfl(jfl),ngrpfl(jfl),jfl1
             END DO
@@ -99,9 +101,9 @@
             
             ! Test to find the grid point coordonate with the geographical position            
-            DO jfl = jpnrstarfl+1, jpnfl
+            DO jfl = jpnrstflo+1, jpnfl
                ihtest(jfl) = 0
                ivtest(jfl) = 0
                ikmfl(jfl) = 0
-# if defined key_mpp
+# if   defined key_mpp_mpi   ||   defined key_mpp_shmem
                DO ji = MAX(nldi,2), nlei
                   DO jj = MAX(nldj,2), nlej
@@ -140,9 +142,9 @@
             
             ! A zero in the sum of the arrays "ihtest" and "ivtest"             
-# if defined key_mpp
-            CALL mpp_sum(ihtest,jpnfl,iwork)
-            CALL mpp_sum(ivtest,jpnfl,iwork)
+# if   defined key_mpp_mpi   ||   defined key_mpp_shmem
+            CALL mpp_sum(ihtest,jpnfl)
+            CALL mpp_sum(ivtest,jpnfl)
 # endif 
-            DO jfl = jpnrstarfl+1, jpnfl
+            DO jfl = jpnrstflo+1, jpnfl
                IF( (ihtest(jfl) > 1 ) .OR. ( ivtest(jfl) > 1) ) THEN
                   IF(lwp) WRITE(numout,*) 'THE FLOAT',jfl,' IS NOT IN ONLY ONE MESH'
@@ -156,5 +158,5 @@
             
             ! We compute the distance between the float and the face of the mesh            
-            DO jfl = jpnrstarfl+1, jpnfl               
+            DO jfl = jpnrstflo+1, jpnfl               
                ! Made only if the float is in the domain of the processor              
                IF( (iimfl(jfl) >= 0) .AND. (ijmfl(jfl) >= 0) ) THEN
@@ -182,31 +184,30 @@
                   ! Translation of this distances (in meter) in indexes
                   
-                  zgifl(jfl-jpnrstarfl)= (iimfl(jfl)-0.5) + zdxab/e1u(iimfl(jfl)-1,ijmfl(jfl)) + (mig(1)-jpizoom)
-                  zgjfl(jfl-jpnrstarfl)= (ijmfl(jfl)-0.5) + zdyad/e2v(iimfl(jfl),ijmfl(jfl)-1) + (mjg(1)-jpjzoom)
-                  zgkfl(jfl-jpnrstarfl) = (( fsdepw(ji,jj,ikmfl(jfl)+1) - flzz(jfl) )* ikmfl(jfl))  &
+                  zgifl(jfl-jpnrstflo)= (iimfl(jfl)-0.5) + zdxab/e1u(iimfl(jfl)-1,ijmfl(jfl)) + (mig(1)-jpizoom)
+                  zgjfl(jfl-jpnrstflo)= (ijmfl(jfl)-0.5) + zdyad/e2v(iimfl(jfl),ijmfl(jfl)-1) + (mjg(1)-jpjzoom)
+                  zgkfl(jfl-jpnrstflo) = (( fsdepw(ji,jj,ikmfl(jfl)+1) - flzz(jfl) )* ikmfl(jfl))  &
                                         / (  fsdepw(ji,jj,ikmfl(jfl)+1) - fsdepw(ji,jj,ikmfl(jfl) ) )   &
                                         + (( flzz(jfl)-fsdepw(ji,jj,ikmfl(jfl)) ) *(ikmfl(jfl)+1))   &
                                         / (  fsdepw(ji,jj,ikmfl(jfl)+1) - fsdepw(ji,jj,ikmfl(jfl)) ) 
                ELSE
-                  zgifl(jfl-jpnrstarfl) = 0.
-                  zgjfl(jfl-jpnrstarfl) = 0.
-                  zgkfl(jfl-jpnrstarfl) = 0.
+                  zgifl(jfl-jpnrstflo) = 0.
+                  zgjfl(jfl-jpnrstflo) = 0.
+                  zgkfl(jfl-jpnrstflo) = 0.
                ENDIF
             END DO
             
             ! The sum of all the arrays zgifl, zgjfl, zgkfl give 3 arrays with the positions of all the floats.
-# if defined key_mpp
-
-            CALL mpp_sum( zgjfl, jpnnewfl )
-            CALL mpp_sum( zgkfl, jpnnewfl )
-            IF(lwp) WRITE(numout,*) (zgifl(jfl),jfl=1,jpnnewfl)
-            IF(lwp) WRITE(numout,*) (zgjfl(jfl),jfl=1,jpnnewfl)
-            IF(lwp) WRITE(numout,*) (zgkfl(jfl),jfl=1,jpnnewfl) 
-# endif
+            IF( lk_mpp )   THEN
+               CALL mpp_sum( zgjfl, jpnnewflo )   ! sums over the global domain
+               CALL mpp_sum( zgkfl, jpnnewflo )
+               IF(lwp) WRITE(numout,*) (zgifl(jfl),jfl=1,jpnnewflo)
+               IF(lwp) WRITE(numout,*) (zgjfl(jfl),jfl=1,jpnnewflo)
+               IF(lwp) WRITE(numout,*) (zgkfl(jfl),jfl=1,jpnnewflo) 
+            ENDIF
            
-            DO jfl = jpnrstarfl+1, jpnfl
-               tpifl(jfl) = zgifl(jfl-jpnrstarfl)
-               tpjfl(jfl) = zgjfl(jfl-jpnrstarfl)
-               tpkfl(jfl) = zgkfl(jfl-jpnrstarfl)
+            DO jfl = jpnrstflo+1, jpnfl
+               tpifl(jfl) = zgifl(jfl-jpnrstflo)
+               tpjfl(jfl) = zgjfl(jfl-jpnrstflo)
+               tpkfl(jfl) = zgkfl(jfl-jpnrstflo)
             END DO
          ENDIF
@@ -234,5 +235,5 @@
             ivtest(jfl) = 0
             ikmfl(jfl) = 0
-# if defined key_mpp
+# if   defined key_mpp_mpi   ||   defined key_mpp_shmem
             DO ji = MAX(nldi,2), nlei
                DO jj = MAX(nldj,2), nlej
@@ -271,8 +272,6 @@
          
          ! A zero in the sum of the arrays "ihtest" and "ivtest"          
-# if defined key_mpp
-         CALL mpp_sum(ihtest,jpnfl,iwork)
-         CALL mpp_sum(ivtest,jpnfl,iwork)
-# endif
+         IF( lk_mpp )   CALL mpp_sum(ihtest,jpnfl)   ! sums over the global domain
+         IF( lk_mpp )   CALL mpp_sum(ivtest,jpnfl)
 
          DO jfl = 1, jpnfl
@@ -327,14 +326,12 @@
          
          ! The sum of all the arrays tpifl, tpjfl, tpkfl give 3 arrays with the positions of all the floats. 
-# if defined key_mpp
-         CALL mpp_sum( tpifl , jpnfl )
-         CALL mpp_sum( tpjfl , jpnfl )
-         CALL mpp_sum( tpkfl , jpnfl )
-         CALL mpp_sum( idomfl, jpnfl )
-# endif
+         IF( lk_mpp )   CALL mpp_sum( tpifl , jpnfl )   ! sums over the global domain
+         IF( lk_mpp )   CALL mpp_sum( tpjfl , jpnfl )
+         IF( lk_mpp )   CALL mpp_sum( tpkfl , jpnfl )
+         IF( lk_mpp )   CALL mpp_sum( idomfl, jpnfl )
       ENDIF
             
       ! Print the initial positions of the floats
-      IF( .NOT. ln_rstarfl ) THEN 
+      IF( .NOT. ln_rstflo ) THEN 
          ! WARNING : initial position not in the sea         
          DO jfl = 1, jpnfl
